// 100 puncte
// Constantin Galatan
#include <fstream>
#include <vector>
#include <iostream>
#include <cmath>
#define pb push_back
#define mp make_pair
#define X first
#define Y second
using namespace std;

ifstream fin("biperm.in");
ofstream fout("biperm.out");

typedef pair<int, int> PII;
vector<int> a, b, A, B, fa, fb;   //
vector<pair<PII, PII> > m;   // <<x, prima_ap_x>, <x, a_doua_ap_x>>
vector<PII> stk, sol;
vector<bool> s;
int n, S, cicluri, nrmin, nrsel;
bool autociclu;

void Read();
void Solve();
void Write();
vector<PII> Go(int, int, int);

int main()
{
    Read();
    Solve();
    Write();
    fin.close();
    fout.close();
    return 0;
}

void Read()
{
	fin >> n;
    a.resize(n + 1); b.resize(n + 1); s.resize(n + 1);
    m.resize(n + 1); fa.resize(n + 1); fb.resize(n + 1);
	for ( int i = 1; i <= n; ++i )
	    fin >> a[i], fa[a[i]]++;
	for ( int i = 1; i <= n; ++i )
		fin >> b[i], fb[b[i]]++;
}

void Solve()
{
    for ( int i = 1; i <= n; ++i )
	{
		if ( a[i] == b[i] ) { s[i] = true; continue; }
		if ( m[a[i]].X.X == 0 )
             m[a[i]].X.X = b[i], m[a[i]].X.Y = i;
        else
            m[a[i]].Y.X = b[i], m[a[i]].Y.Y = i;
		if ( m[b[i]].X.X == 0 )
            m[b[i]].X.X = -a[i], m[b[i]].X.Y = i;
        else
            m[b[i]].Y.X = - a[i], m[b[i]].Y.Y = i;
	}

    A = a, B = b;
    for ( int i = 1; i <= n; ++i )
        if ( fa[a[i]] == 1 ) nrsel++;
    for ( int j = 1; j <= n; ++j )
    {
        if ( s[j] ) continue;
        stk.clear(); S = a[j]; autociclu = false;
        sol = Go(a[j], j, 0);
        int inv = 0, dir = 0, aux, k;
        for ( size_t i = 1; i < sol.size(); ++i )
            if ( sol[i].X < 0 ) inv++;
            else dir++;
        if ( sol.size() != 3 ) nrmin += min(dir, inv);
        if ( sol.size() == 3 ) {
            if ( autociclu == false  ) {
                nrmin++; k = sol[0].Y;
                aux = A[k]; A[k] = B[k]; B[k] = aux;
            }
        }
        else
        for ( size_t i = 1; i < sol.size() ; i++ )
            if ( dir > inv ) {
                if ( sol[i].X < 0 )
                    k = sol[i].Y, aux = A[k], A[k] = B[k], B[k] = aux;
            }
            else
                if ( sol[i].X > 0 )
                    k = sol[i].Y, aux = A[k], A[k] = B[k], B[k] = aux;
        cicluri++;
    }
}

void Write()
{
     fout << (1 << cicluri) << ' ';  // cicluri distincte
     if ( nrsel == n )
     {
        fout << 0 << '\n';
        for ( int i = 1; i <= n; ++i )
            fout << a[i] << ' ';
        fout << '\n';
        for ( int i = 1; i <= n; ++i )
            fout << b[i] << ' ';
        return;
    }
    else
        fout << nrmin << '\n';        // nr minim de interschimbari pentru o bipermutare perfecta
     for ( int i = 1; i <= n; ++i )
        fout << A[i] << ' ';
    fout << '\n';
    for ( int i = 1; i <= n; ++i )
        fout << B[i] << ' ';
}

vector<PII> Go(int x, int i, int tata)
{
    stk.pb(mp(x, i)); s[i] = true;
    if ( x < 0 ) x = -x;
    if (  x == S && tata != 0 ) return stk;
    int u = m[x].X.X, v = m[x].Y.X;
    if ( u == v ) {  // ciclu x / y  y / x
        s[m[x].X.Y] = true; s[m[x].Y.Y] = true;
        stk.pb(mp(u, i)); stk.pb(mp(-x, i)); return stk;
    }
    if ( fabs(u) == fabs(v) ) {
        autociclu = true; s[m[x].Y.Y] = true;
        return Go(u, m[x].X.Y, x);
    }
    if ( u < 0 && v < 0 ) { // x e in a
        if ( -u != x && -u != tata) return Go(u, m[x].X.Y, x);
        if ( -v != x && -v != tata) return Go(v, m[x].Y.Y, x);
    }
    // x e in b
    if ( u < 0 ) {
        if ( -u != x && -u != tata)  // deci v > 0
            return Go(u, m[x].X.Y, x);
    }
    else  // u > 0 x e din a
        if ( u && u != x && u != tata) return Go(u, m[x].X.Y, x);

    if ( v < 0 ) {
        if ( -v != x && -v != tata ) return Go(v, m[x].Y.Y, x);  // deci u > 0 x e din b
    }
    else
        if ( v && v != x && v!= tata) return Go(v, m[x].Y.Y, x); // u < 0
    return stk;
}
