#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

const char iname[] = "subsecvente.in";
const char oname[] = "subsecvente.out";

typedef long long i64;


void read_in(string &main_str, vector <string> &strs) {
    ifstream fin(iname);
    int n;  fin >> n;
    fin >> main_str;
    for (string str; fin >> str; )
        strs.push_back(str);
    fin.close();
}

void write_out(int length) {
    ofstream out(oname);
    out << length << "\n";
    out.close();
}

i64 get_number(string& str, size_t i, size_t length) {
    i64 number = 0;

    for (size_t step = 0; step < length; ++ step)
        number = (number << 1) | int(str[i + step] - 'a');
    return number;
}

int search_number(i64 number, size_t length, vector <string>& strs) {
    i64 number_mask = (1LL << length) - 1;  // Length should be less than 63.

    for (size_t i = 0; i < strs.size(); ++ i) {
        if (strs[i].size() < length) {
            return 0;
        }
        i64 number_str = get_number(strs[i], 0, length);
        bool numbers_match = (number_str == number);
        for (size_t j = length; j < strs[i].size() && !numbers_match; ++ j) {
            number_str = (number_str << 1) | int(strs[i][j] - 'a');
            number_str = number_str & number_mask;
            numbers_match |= (number_str == number);
        }
        if (!numbers_match) {
            return 0;
        }
    }
    return 1;
}

int main(void) {
    string main_str; vector <string> strs;
    read_in(main_str, strs);

    size_t length_ans = 0;
    for (size_t length = 62; length >= 1 && !length_ans; -- length) {
        i64 number_mask = (1LL << length) - 1;

        if (main_str.size() >= length) {
            i64 number = get_number(main_str, 0, length);
            if (search_number(number, length, strs))
                length_ans = length;
            for (size_t i = length; i < main_str.size() && !length_ans; ++ i) {
                number = (number << 1) | int(main_str[i] - 'a');
                number = number & number_mask;
                if (search_number(number, length, strs))
                    length_ans = length;
            }
        }
    }
    write_out(length_ans);

    return 0;
}