#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cassert>
using namespace std;

const char iname[] = "subsecvente.in";
const char oname[] = "subsecvente.out";

typedef unsigned long long u64;

vector <string> strs;
set < pair <u64, int> > numbers[2];


void read_in(vector <string> &strs) {
    ifstream fin(iname);
    int n;  fin >> n;

    for (string str; fin >> str; )
        strs.push_back(str);
    fin.close();
    assert(n == (int)strs.size());
}

void write_out(int length) {
    ofstream out(oname);
    out << length << "\n";
    out.close();
}

u64 get_number(string& str, int index, int length) {
    u64 number = 0;

    for (int i = index; i < index + length; ++ i)
        number = (number << 1) | (str[i] - 'a');
    return number & ((1LL << length) - 1);
}

void add_number(u64 number, int length, int index, bool init) {
    if (init || numbers[1 ^ index].find(make_pair(number, length)) != numbers[1 ^ index].end())
        numbers[index].insert(make_pair(number, length));
}

int main(void) {
    read_in(strs);

    int step_ans = 0;

    for (int length = 61; length >= 1; -- length) {
        int step = 0; 
        u64 number_mask = (1LL << length) - 1;

        for (int i = 0; i < strs.size(); ++ i) {
            step ^= 1;
            numbers[step].clear();
            if (length > strs[i].size())
                break;

            u64 curr_number = get_number(strs[i], 0, length);
            add_number(curr_number, length, step, !i);

            for (int j = length; j < strs[i].size(); ++ j) {
                curr_number = (curr_number << 1) | int(strs[i][j] - 'a');
                curr_number = curr_number & number_mask;
                add_number(curr_number, length, step, !i);
            } 
            if (numbers[step].size() == 0)
                break;
        }
        if (numbers[step].size() > 0) {
            step_ans = step;
            break;
        }
    }

    set < pair <u64, int> >::iterator it;
    int max_length = 0;

    for (it = numbers[step_ans].begin(); it != numbers[step_ans].end(); ++ it) {
        max_length = max(max_length, it->second);
    }
    write_out(max_length);

    return 0;
}